/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*	$FreeBSD: src/sys/netinet6/ip6_var.h,v 1.10 2002/10/16 01:54:45 sam Exp $	*/
/*	$KAME: ip6_var.h,v 1.62 2001/05/03 14:51:48 itojun Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip_var.h	8.1 (Berkeley) 6/10/93
 */
 
#ifndef _IP6_VAR_H_
#define _IP6_VAR_H_

#ifdef SUPPORT_INET6

/*
 *  IPv6 إåڥɥޥ
 */

#define IF_IP6_HDR_SIZE			(IF_HDR_SIZE + IP6_HDR_SIZE)

#define GET_IP6_HDR(nbuf)		((T_IP6_HDR*)((nbuf)->buf + IF_HDR_SIZE))
#define GET_IP6_SDU(nbuf)		((UB*)((nbuf)->buf) + GET_IF_IP6_HDR_SIZE(nbuf))
#define GET_IP6_NEXT_HDR(nbuf)		((UB*)((nbuf)->buf) + IF_IP6_HDR_SIZE)

#define GET_IP6_HDR_SIZE(iph)		(get_ip6_hdr_size(iph))
#define GET_IP6_SDU_SIZE(iph)		(ntohs((iph)->plen))
#define GET_IF_IP6_HDR_SIZE(nbuf)	(IF_HDR_SIZE + (GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf))))

#define SET_IP6_SDU_SIZE(iph,slen)	((iph)->plen=htons(slen))

/* ip6_output Υե饰 */

#define IPV6_OUT_FLG_DAD		0x0100	/* ʣɥ쥹	*/
#define IPV6_OUT_FLG_HOP_LIMIT		0x0200	/* ۥåץߥåȻ	*/

/* ۥåץߥåȥե饰դۥåץߥåͤޥ */

#define IPV6_OUT_GET_HOP_LIMIT(f)	((f)&0x00ff)
#define IPV6_OUT_SET_HOP_LIMIT(f,l)	((f)|(l))

/*
 *  ip6_unknown_opt -- ̤ΤΥץν
 *
 *    :
 *
 *      0 ʾ 			ץĹ
 *      IP6_OPT_RET_ERR (-1)	顼ƽ¦ǥͥåȥХåե롣
 *      IP6_OPT_RET_REL (-2)	顼ͥåȥХåեϳƤ롣
 */

#define IP6_OPT_RET_ERR		(-1)
#define IP6_OPT_RET_REL		(-2)

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

#define T_TCP_IP_Q_HDR			T_TCP_IP6_Q_HDR

#define IF_IP_HDR_SIZE			IF_IP6_HDR_SIZE

#define GET_IP_HDR(nbuf)		GET_IP6_HDR(nbuf)
#define GET_IP_SDU(nbuf)		GET_IP6_SDU(nbuf)

#define GET_IP_HDR_SIZE(iph)		GET_IP6_HDR_SIZE(iph)
#define GET_IP_SDU_SIZE(iph)		GET_IP6_SDU_SIZE(iph)
#define GET_IF_IP_HDR_SIZE(nbuf)	GET_IF_IP6_HDR_SIZE(nbuf)

#define SET_IP_SDU_SIZE(iph,len)	SET_IP6_SDU_SIZE(iph,len)

#define IP_OUTPUT(nbuf,tmout)		ip6_output(nbuf,0,tmout)
#define IP_INIT()			ip6_init()
#define IP_REMOVE_OPTIONS(nbuf)		ip6_remove_exthdrs(nbuf)

/*
 *  IPv6  MMTU ΥͥåȥХåե
 */

typedef struct t_net_buf_ipv6_mmtu {
	UH		len;	/* ǡĹ		*/
	UB		idix;	/* mpfid Υǥå	*/
	UB		unit;	/* 󥿥եֹ	*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	UB		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB		halign[4 - IF_HDR_ALIGN];
#endif
	UB		buf[IF_HDR_SIZE + IPV6_MMTU];
				/* Хåե		*/
	} T_NET_BUF_IPV6_MMTU;

/*
 *  65536 ƥåȥΥͥåȥХåե
 */

typedef struct t_net_buf6_65536 {
	UH		len;	/* ǡĹ		*/
	UB		idix;	/* mpfid Υǥå	*/
	UB		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	UB		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB		halign[4 - IF_HDR_ALIGN];
#endif
	UB		buf[IF_IP6_HDR_SIZE + 65536];
				/* Хåե		*/
#if defined(IF_PDU_HDR_PADDING)
	UB		padding[IF_PDU_HDR_PADDING];
#endif				/* إå;ʬ		*/
	} T_NET_BUF6_65536;

#ifdef IP6_CFG_FRAGMENT

/*
 *  ƹ塼 IPv6 إå
 */

typedef struct t_qip6_hdr {
	UW vcf;		/* Version:        4 bit		*/
			/* Traffic Class:  8 bit		*/
			/* Flow Label:    20 bit		*/
	UH plen;	/* Payload Length			*/
	UB next;	/* Next Header				*/
	UB hlim;	/* Hop Limit				*/
	T_IN6_ADDR src;	/* Source Address			*/
	T_NET_BUF  *next_frag;	/*  IPv6 ե饰	*/
	UH foff;	/* ҥإåΥեå		*/
	UH flen;	/* Ĺ				*/
	UH ftim;	/* ƹॢ			*/
	UH dummy1;
	UB dummy2[sizeof(T_IN6_ADDR) - (sizeof(T_NET_BUF*) + sizeof(UH) * 4)];
	} T_QIP6_HDR;

#define QIP6_HDR_SIZE			(sizeof(T_QIP6_HDR))
#define IF_QIP6_HDR_SIZE		(IF_HDR_SIZE + QIP6_HDR_SIZE)

#define GET_QIP6_HDR(nbuf)		((T_QIP6_HDR*)((nbuf)->buf + IF_HDR_SIZE))
#define GET_QIP6_SDU(nbuf)		((UB*)(nbuf)->buf + GET_IF_QIP6_HDR_SIZE(nbuf))

#define GET_QIP6_HDR_SIZE(iph)		((UB)IP6_VHL_HL((iph)->vhl) << 2)
#define GET_IF_QIP6_HDR_SIZE(nbuf)	(IF_HDR_SIZE + (GET_QIP6_HDR_SIZE(GET_QIP6_HDR(nbuf))))

/*
 *  ǡƹѥͥåȥХåե
 */

typedef struct t_net_buf6_reassm {
	UH		len;	/* ǡĹ		*/
	UB		idix;	/* mpfid Υǥå	*/
	UB		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	UB		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB		align[4 - IF_HDR_ALIGN];
#endif
	UB		buf[IP6_CFG_FRAG_REASSM_SIZE];
				/* Хåե		*/
	} T_NET_BUF6_REASSM;

#endif	/* of #ifdef IP6_CFG_FRAGMENT */

/*
 *  TCP κƹ塼ˤ IPv6 إå
 */

typedef struct t_tcp_ip6_q_hdr {
	UB vc;		/* Version:        4 bit		*/
	UB cf;		/* Traffic Class:  8 bit		*/
			/* Flow Label:     4 bit (20 bit)	*/
	UH thoff;	/* TCP إåΥեå		*/
	UH plen;	/* Payload Length			*/
	UB next;	/* Next Header				*/
	UB hlim;	/* Hop Limit				*/
	T_IN6_ADDR src;	/* Source Address			*/
	T_IN6_ADDR dst;	/* Destination Address			*/
	} T_TCP_IP6_Q_HDR;

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_in6_ifstat {
	UW	ipv6IfStatsInReceives;
	UW	ipv6IfStatsInHdrErrors;
/*	UW	ipv6IfStatsInTooBigErrors;*/
/*	UW	ipv6IfStatsInNoRoutes;*/
	UW	ipv6IfStatsInAddrErrors;
	UW	ipv6IfStatsInUnknownProtos;
	UW	ipv6IfStatsInTruncatedPkts;
/*	UW	ipv6IfStatsInDiscards;*/
/*	UW	ipv6IfStatsInDelivers;*/
/*	UW	ipv6IfStatsOutForwDatagrams;*/
	UW	ipv6IfStatsOutRequests;
	UW	ipv6IfStatsOutDiscards;
	UW	ipv6IfStatsOutFragOKs;
	UW	ipv6IfStatsOutFragFails;
	UW	ipv6IfStatsOutFragCreates;
	UW	ipv6IfStatsReasmReqds;
	UW	ipv6IfStatsReasmOKs;
	UW	ipv6IfStatsReasmFails;
	UW	ipv6IfStatsInMcastPkts;
	UW	ipv6IfStatsOutMcastPkts;
} T_IN6_IFSTAT;

extern T_IN6_IFSTAT in6_ifstat;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿ
 */

extern ER ip6_output (T_NET_BUF *output, UH flags, TMO tmout);
extern void ip6_init (void);
extern char *ip6_get_prev_hdr (T_NET_BUF *nbuf, UINT off);
extern UINT get_ip6_hdr_size (T_IP6_HDR *iph);
extern ER_UINT ip6_nexthdr (T_NET_BUF *nbuf, UINT off, UINT proto, UINT *nextp);
extern ER_UINT ip6_lasthdr (T_NET_BUF *nbuf, UINT off, UINT proto, UINT *nextp);
extern ER_UINT ip6_unknown_opt (T_NET_BUF *input, UB *opt);
extern UINT dest6_input  (T_NET_BUF **inputp, UINT *offp, UINT *nextp);
extern UINT route6_input (T_NET_BUF **inputp, UINT *offp, UINT *nextp);
extern UINT frag6_input  (T_NET_BUF **inputp, UINT *offp, UINT *nextp);
extern void frag6_timer (void);
extern ER ip6_remove_exthdrs (T_NET_BUF *nbuf);

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _IP6_VAR_H_ */
